<template>
  <div class="range"></div>
</template>

<script>
  import noUiSlider from 'nouislider';
  import 'nouislider/distribute/nouislider.css'

  export default {
    name: 'Range',
    props: {
      min: {
        type: Number,
        required: true
      },

      max: {
        type: Number,
        required: true
      },

      step: {
        type: Number,
        default: 1
      },

      value: Array,

      changeFromInput: {
        type: Boolean,
        default: false
      },

      filterType: {
        type: String,
        default: null
      }
    },
    model: {
      event: 'update'
    },
    data: () => ({
      slider: null
    }),
    mounted() {
      this.init();

      this.slider.noUiSlider.on('slide', (values) => {
        values = values.map((value) => parseInt(value));

        if (this.filterType === 'time') {
          values = values.map((value) => value < 10 ? `0${value}:00` : `${value}:00`)
        }

        this.$emit('update', values)
      })
    },
    watch: {
      value(val) {
        val = val.map((item) => parseInt(item));

        if (this.changeFromInput) {
          this.slider.noUiSlider.set(val);

          this.$emit('rangeChanged');
        }

        if (isNaN(val[0]) || isNaN(val[1])) {
          this.slider.noUiSlider.set(this.startValues);
        }

        if (val.length === 0) {
          this.slider.noUiSlider.set(this.startValues);
        }
      }
    },
    computed: {
      startValues() {
        return [
          this.value[0] ? parseInt(this.value[0]) : this.min,
          this.value[1] ? parseInt(this.value[1]) : this.max,
        ]
      }
    },
    methods: {
      init() {
        this.slider = this.$el;

        noUiSlider.create(this.slider, {
          start: this.startValues,
          connect: [false, true, false],
          range: {
            'min': [this.min],
            'max': [this.max]
          },
          step: this.step
        });
      }
    }
  }
</script>

<style lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .range.noUi-target {
    width: 100%;
    height: rem(4);

    border: none;
    background: $gray;
    box-shadow: inset rem(2) rem(2) rem(2) rgba(213, 220, 228, 0.6);
    border-radius: rem(4);

    .noUi-connects {
      border-radius: rem(4);

      .noUi-connect {
        background: $gradient-green;
      }
    }

    .noUi-handle {
      top: rem(-12);

      height: rem(28);
      width: rem(28);

      border-radius: 50%;
      background: $gradient-green;
      box-shadow: none;
      border: none;

      cursor: pointer;

      &:focus {
        background: $green;
      }

      &::before, &::after {
        content: none;
        display: none;
      }
    }
  }
</style>
